%define as_major 5
%define as_minor 2
%define as_rev 0
%define seam_version 2.2.6.EAP5

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

# For FCS
##%#bcond_without bundle

# For BETA2/GA
%bcond_with bundle

%bcond_with build_hornetq_only

Summary:        Red Hat Enterprise Application Platform Documentation
Name:           rh-eap-docs
Version:        %{as_major}.%{as_minor}.%{as_rev}
Release:        7%{?dist}
Epoch:          0
License:        LGPL
BuildArch:      noarch
Group:          Documentation
%if %with bundle
Source0:        %{name}.zip
%endif
Source1:        readme.html
Source6:        web-services-examples.zip
#svn export https://svn.jboss.org/repos/jbossas/branches/JBPAPP_5_1/webservices/src/etc/examples/ web-services-examples
#Exported revision 111252.
#zip -r web-services-examples.zip web-services-examples

BuildRequires:  jpackage-utils,zip,unzip
#needed for hornetq examples
BuildRequires:  jbossas-hornetq-examples >= 0:%{version}
#needed for resteasy examples
BuildRequires:  resteasy-examples >= 0:1.2.1-14
#needed for JBM examples
BuildRequires:  jboss-messaging-examples >= 0:1.4.8-11
Requires(pre):  jpackage-utils
Requires:       jboss-seam2-docs >= 0:%{seam_version}
Requires:       hibernate3-javadoc >= 1:3.3.2-1.5.GA_CP05
Requires:       hibernate3-ejb-persistence-3.0-api-javadoc >= 1:1.0.2
Requires:       hibernate3-annotations-javadoc >= 0:3.4.0-3.3.GA_CP05
Requires:       hibernate3-entitymanager-javadoc >= 0:3.4.0-4.4.GA_CP05
Requires:       hibernate3-commons-annotations-javadoc >= 0:3.1.0-1.5.1.1
Requires:       hibernate3-validator-javadoc >= 0:3.1.0-1.5.4
Requires:       hibernate3-search-javadoc >= 0:3.1.1-2.3.GA_CP05

Requires:       resteasy-javadoc >= 0:1.2.1-14
Requires:       resteasy-manual >= 0:1.2.1-14
Requires:       jbossts-javadoc >= 1:4.6.1-11

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

%description
The %{name} package contains javadoc api's for the 
Red Hat Enterprise Application Platform.

%package zip
Summary:        Zipped docs for Red Hat Enterprise Application Platform.
Group:          Documentation

%description zip
Zip file containing documentation for Red Hat Enterprise Application Platform.

%package examples
Summary:        Examples for Red Hat Enterprise Application Platform.
Group:          Documentation/Examples

%description examples
Examples for Red Hat Enterprise Application Platform.

%prep
%if %with bundle
%setup -q -c -n rh-eap-docs
# Remove un-necessary common_content dir (we change readme below to point to new common_content dir)
rm -rf jboss-eap-%{as_major}.%{as_minor}-fcs/Common_Content
# Remove backup file
rm -rf jboss-eap-%{as_major}.%{as_minor}-fcs/doc/index.html~
mv jboss-eap-%{as_major}.%{as_minor}-fcs jboss-eap-%{as_major}.%{as_minor}
%else
mkdir -p jboss-eap-%{as_major}.%{as_minor}
%endif
find . -name "*.jar" -exec rm -f {} \;

%build
cp -p %{SOURCE1} jboss-eap-%{as_major}.%{as_minor}/

# Copy over the examples
mkdir -p jboss-eap-%{as_major}.%{as_minor}/doc/examples/seam
pushd jboss-eap-%{as_major}.%{as_minor}/doc/examples
unzip -q %{_javadir}/jbossas-fordev/jboss-messaging-examples-*.zip
mv extra/jbm-examples jboss-messaging-examples/
rm -fr extra
popd
#Use examples from resteasy-examples
mkdir -p jboss-eap-%{as_major}.%{as_minor}/doc/examples/resteasy-examples
cp -r %{_javadir}/resteasy/examples/* jboss-eap-%{as_major}.%{as_minor}/doc/examples/resteasy-examples/
#Use ws examples from svn co
unzip -q -d jboss-eap-%{as_major}.%{as_minor}/doc/examples %{SOURCE6}
# from hornetq-eap-examples.zip of jbossas-hornetq build
mkdir -p jboss-eap-%{as_major}.%{as_minor}/doc/examples/hornetq-examples/
unzip -q %{_javadir}/jbossas-fordev/hornetq-eap-examples.zip
cp -pr docs/examples/hornetq-examples jboss-eap-%{as_major}.%{as_minor}/doc/examples/
rm -fr docs

#create readme for seam
cat > jboss-eap-%{as_major}.%{as_minor}/doc/examples/seam/readme.html << EOF
The seam examples can be found in jboss-eap-%{as_major}.%{as_minor}/seam/examples/ in the main zip.
EOF

# ------------------------------------------
# Install
# ------------------------------------------
%install
rm -rf $RPM_BUILD_ROOT

pushd jboss-eap-%{as_major}.%{as_minor}

  ### manuals ###
  install -dm 755 $RPM_BUILD_ROOT%{_docdir}/enterprise-application-platform-%{version}/jbossts/api
  install -dm 755 $RPM_BUILD_ROOT%{_docdir}/enterprise-application-platform-%{version}/hibernate/api
  install -dm 755 $RPM_BUILD_ROOT%{_docdir}/enterprise-application-platform-%{version}/seam
  install -dm 755 $RPM_BUILD_ROOT%{_docdir}/enterprise-application-platform-%{version}/resteasy

%if %with bundle
  # We want everything except api and example dirs
  cp -pr doc/* $RPM_BUILD_ROOT%{_docdir}/enterprise-application-platform-%{version}
  rm -rf $RPM_BUILD_ROOT%{_docdir}/enterprise-application-platform-%{version}/examples
  rm -rf $RPM_BUILD_ROOT%{_docdir}/enterprise-application-platform-%{version}/jbossts/api/*
  rm -rf $RPM_BUILD_ROOT%{_docdir}/enterprise-application-platform-%{version}/hibernate/api/*
%endif

  # Link to javadocs from /usr/share/docs/..
  ln -s %{_javadocdir}/jbossts $RPM_BUILD_ROOT%{_docdir}/enterprise-application-platform-%{version}/jbossts/api/jta
  ln -s %{_javadocdir}/hibernate3-core $RPM_BUILD_ROOT%{_docdir}/enterprise-application-platform-%{version}/hibernate/api/hibernate-core
  ln -s %{_javadocdir}/hibernate3-ejb-persistence-3.0-api $RPM_BUILD_ROOT%{_docdir}/enterprise-application-platform-%{version}/hibernate/api/ejb-persistence-3.0-api
  ln -s %{_javadocdir}/hibernate3-annotations $RPM_BUILD_ROOT%{_docdir}/enterprise-application-platform-%{version}/hibernate/api/hibernate-annotations
  ln -s %{_javadocdir}/hibernate3-entitymanager $RPM_BUILD_ROOT%{_docdir}/enterprise-application-platform-%{version}/hibernate/api/hibernate-entitymanager
  ln -s %{_javadocdir}/hibernate3-commons-annotations $RPM_BUILD_ROOT%{_docdir}/enterprise-application-platform-%{version}/hibernate/api/hibernate-commons-annotations
  ln -s %{_javadocdir}/hibernate3-validator $RPM_BUILD_ROOT%{_docdir}/enterprise-application-platform-%{version}/hibernate/api/hibernate-validator
  ln -s %{_javadocdir}/hibernate3-search $RPM_BUILD_ROOT%{_docdir}/enterprise-application-platform-%{version}/hibernate/api/hibernate-search
  ln -s %{_javadocdir}/jboss-seam2-%{seam_version}/api $RPM_BUILD_ROOT%{_docdir}/enterprise-application-platform-%{version}/seam
  ln -s %{_javadocdir}/resteasy-1.2.1 $RPM_BUILD_ROOT%{_docdir}/enterprise-application-platform-%{version}/resteasy

  # Examples
  install -dm 755 $RPM_BUILD_ROOT%{_datadir}/enterprise-application-platform-%{version}
  cp -pr doc/examples/resteasy-examples $RPM_BUILD_ROOT%{_datadir}/enterprise-application-platform-%{version}
  cp -pr doc/examples/jboss-messaging-examples $RPM_BUILD_ROOT%{_datadir}/enterprise-application-platform-%{version}
  cp -pr doc/examples/web-services-examples $RPM_BUILD_ROOT%{_datadir}/enterprise-application-platform-%{version}
  cp -pr doc/examples/hornetq-examples $RPM_BUILD_ROOT%{_datadir}/enterprise-application-platform-%{version}

  # 1. Copy over the readme
  cp -p %{SOURCE1} $RPM_BUILD_ROOT%{_docdir}/enterprise-application-platform-%{version}

  %if %with bundle
  # 2. Fix css link in readme to make it look in 
  # ./doc/Common_Content instead of in ./Common_Content
  sed -i -e s:"Common_Content":"doc/Common_Content": *.html
  %endif

  ### docs zip ###
  zip -qr ../%{name}-%{version}-%{release}.zip *
popd

install -dm 755 $RPM_BUILD_ROOT%{_javadir}/jbossas-fordev
install -m 644 %{name}-%{version}-%{release}.zip $RPM_BUILD_ROOT%{_javadir}/jbossas-fordev/%{name}-%{version}-%{release}.zip

# ------------------------------
# Clean the build
# ------------------------------
%clean
rm -rf $RPM_BUILD_ROOT

# ------------------------------

%files
%defattr(644,root,root,755)
%doc %{_docdir}/enterprise-application-platform-%{version}

%files zip
%defattr(644,root,root,755)
%{_javadir}/jbossas-fordev

%files examples
%defattr(644,root,root,755)
%doc %{_datadir}/enterprise-application-platform-%{version}

# ------------------------------

%changelog
* Fri Jan 11 2013 Hui Wang <huwang@redhat.com> - 0:5.2.0-7
- Rebuild

* Tue Nov 27 2012 Hui Wang <huwang@redhat.com> - 0:5.2.0-6
- Rebuild

* Mon Nov 19 2012 Hui Wang <huwang@redhat.com> - 0:5.2.0-5
- Rebuild for 5.2.0.ER5

* Wed Nov 07 2012 Hui Wang <huwang@redhat.com> - 0:5.2.0-4
- Rebuild for 5.2.0.ER4

* Mon Sep 10 2012 Martha Benitez <mbenitez@redhat.com> 5.2.0-3
- Rebuild to get latest jboss-seam2

* Wed Sep 05 2012 Hui Wang <huwang@redhat.com> - 0:5.2.0-2
- Rebuild for 5.2.0.ER2

* Thu Aug 23 2012 Martha Benitez <mbenitez@redhat.com> - 0:5.2.0-1
- Upgrade to 5.2.0

* Thu Nov 10 2011 Martha Benitez <mbenitez@redhat.com> - 0:5.1.2-6
- Rebuild

* Wed Nov 09 2011 Permaine Cheung <pcheung@redhat.com> - 0:5.1.2-5
- Include hq built examples from jbosssa-hornetq-examples

* Tue Nov 08 2011 Martha Benitez <mbenitez@redhat.com> - 0:5.1.2-4
- Rebuild

* Wed Nov 02 2011 Permaine Cheung <pcheung@redhat.com> - 0:5.1.2-3
- Build with HQ examples fix

* Tue Sep 20 2011 Martha Benitez <mbenitez@redhat.com> - 0:5.1.2-2
- Define variable for seam version to avoid broken links

* Tue Sep 13 2011 Permaine Cheung <pcheung@redhat.com> - 0:5.1.2-1
- 5.1.2 build

* Tue May 17 2011 Permaine Cheung <pcheung@redhat.com> - 0:5.1.1-6
- Fix seam javadoc link

* Fri May 13 2011 Permaine Cheung <pcheung@redhat.com> - 0:5.1.1-5
- Rebuild

* Wed May 11 2011 Permaine Cheung <pcheung@redhat.com> - 0:5.1.1-4
- Rebuild

* Wed Apr 27 2011 Permaine Cheung <pcheung@redhat.com> - 0:5.1.1-3
- Unzip from hornetq-eap-examples.zip for hornetq examples
- Use resteasy-examples for resteasy examples
- Use jboss-messaging-examples for JBM examples
- Use co for WS examples

* Tue Apr 26 2011 Martha Benitez <mbenitez@redhat.com> - 0:5.1.1-2
- Upgrade Requires:

* Tue Apr 05 2011 Permaine Cheung <pcheung@redhat.com> 5.1.1-1
- 5.1.1

* Fri Sep 17 2010 Permaine Cheung <pcheung@redhat.com> 5.1.0-7
- Remove hornetq examples

* Fri Sep 10 2010 Permaine Cheung <pcheung@redhat.com> 5.1.0-6
- New hornetq examples from docs team

* Thu Aug 19 2010 Permaine Cheung <pcheung@redhat.com> 5.1.0-5
- New docs bundle from docs team, build for CR3

* Mon Aug 16 2010 Permaine Cheung <pcheung@redhat.com> 5.1.0-4
- New docs bundle from docs team (Hornetq docs still needs to be updated)

* Thu Jul 29 2010 Permaine Cheung <pcheung@redhat.com> 5.1.0-3
- New docs bundle

* Wed Jun 09 2010 Permaine Cheung <pcheung@redhat.com> 5.1.0-2
- Remove seam-examples.zip and add readme to seam referencing to the 
  examples in the main zip

* Tue Jun 08 2010 Permaine Cheung <pcheung@redhat.com> 5.1.0-1
- Build for 5.1.0 CR1
- Remove rh-eap-docs-resteasy-examples.patch as it is now in the docs bundle
- Rename jboss-web-services-examples.zip to web-services-examples.zip
- Add Hornetq examples
- Use macros instead of numbers for version

* Fri May 07 2010 Martha Benitez <mbenitez@redhat.com> - 0:5.0.1-6.1
- rebuilt

* Tue Apr 06 2010 Hui Wang <huwang@redhat.com> 5.0.1-6
- Rebuild

* Tue Mar 16 2010 Martha Benitez <mbenitez@redhat.com> 5.0.1-5
- Add Resteasy manual as a R:

* Fri Mar 12 2010 Permaine Cheung <pcheung@redhat.com> 5.0.1-4
- Build for CR2
- Add Resteasy javadocs as a R:

* Mon Mar 01 2010 Permaine Cheung <pcheung@redhat.com> 5.0.1-3
- Update R: for installation

* Wed Feb 24 2010 Permaine Cheung <pcheung@redhat.com> 5.0.1-2
- Updated docs bundle from the docs team

* Tue Feb 16 2010 Permaine Cheung <pcheung@redhat.com> 5.0.1-1
- Build for EAP 5.0.1 with zips from the new docs bundle from the docs team
- Use readme.html from the docs bundle

* Tue Oct 20 2009 Permaine Cheung <pcheung@redhat.com> 5.0.0-11
- Remove admin-config-guide-examples.zip, and gettingstarted-examples.zip
  as requested by the docs team

* Mon Oct 19 2009 Permaine Cheung <pcheung@redhat.com> 5.0.0-10
- Updated and new examples (admin-config-guide-examples.zip, and 
  gettingstarted-examples.zip) from docs team
- Build for 5.0.0.GA

* Wed Sep 16 2009 Permaine Cheung <pcheung@redhat.com> 5.0.0-9.BETA2
- Build without docs bundle, for BETA2
- Add a patch for a fix missing from the RestEASY examples

* Thu Sep 10 2009 Permaine Cheung <pcheung@redhat.com> 5.0.0-8.FCS
- Fix the with_bundle switch

* Wed Sep 09 2009 Permaine Cheung <pcheung@redhat.com> 5.0.0-7.FCS
- Latest zips from the docs team for FCS
- Added with_bundle switch for including docs bundle (For FCS)

* Wed Sep 02 2009 Fernando Nasser <fnasser@redhat.com> 5.0.0-6
- Latest RESTEasy examples

* Fri Aug 28 2009 Fernando Nasser <fnasser@redhat.com> 5.0.0-5
- Add JBoss Messaging examples

* Mon Aug 24 2009 Permaine Cheung <pcheung@redhat.com> 5.0.0-4
- Rebuild

* Mon Aug 24 2009 Permaine Cheung <pcheung@redhat.com> 5.0.0-3
- Update resteasy examples from svn export

* Mon Aug 24 2009 Permaine Cheung <pcheung@redhat.com> 5.0.0-2
- Add jboss-web-services.zip from the docs team

* Sun Aug 23 2009 Permaine Cheung <pcheung@redhat.com> 5.0.0-1
- Only RESTEasy example, javadocs and readme are in the docs bundle now
- Add hibernate3-search javadocs
- BR jbossts-javadocs

* Mon Aug 10 2009 Permaine Cheung <pcheung@redhat.com> 5.0.0-0.2.CR2.2
- Rebuild

* Thu Aug 06 2009 Permaine Cheung <pcheung@redhat.com> 5.0.0-0.2.CR2.1
- Updated docs from the docs team

* Thu Jul 30 2009 Permaine Cheung <pcheung@redhat.com> 5.0.0-0.1.BETA.3
- Add resteasy pdf

* Thu Jul 30 2009 Permaine Cheung <pcheung@redhat.com> 5.0.0-0.1.BETA.2
- Use URL for release notes instead

* Thu Jul 30 2009 Permaine Cheung <pcheung@redhat.com> 5.0.0-0.1.BETA.1
- First build for 5.0.0.BETA
